/*
 * Copyright (C) 1999-2004 <a href="mailto:mandarax@jbdietrich.com">Jens Dietrich</a>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

package org.mandarax.util.logging;

import org.apache.log4j.Category;
import org.apache.log4j.Level;

/**
 * Logger wrapping the apache log4j framework.
 * 
 * @author <A HREF="mailto:mandarax@jbdietrich.com">Jens Dietrich </A>
 * @version 3.3.1 <9 August 2004>
 * @since 2.3.1
 */
class Log4JLogger implements Logger {

    private static String FQCN = Log4JLogger.class.getName();

    private Category category = null;

    /**
     * Constructor.
     * 
     * @param the
     *            name of the logger.
     */
    Log4JLogger(String loggerName) {
        super();
        category = Category.getInstance(loggerName);
    }

    /**
     * Log an error.
     * 
     * @param message
     *            a message
     * @param exception
     *            an exception or error
     */
    public void error(String message, Throwable exception) {
        category.log(FQCN, Level.ERROR, message, exception);
    }

    /**
     * Log a warning.
     * 
     * @param message
     *            a message
     * @param exception
     *            an exception or error
     */
    public void warn(String message, Throwable exception) {
        category.log(FQCN, Level.WARN, message, exception);
    }

    /**
     * Log an info message.
     * 
     * @param message
     *            a message
     * @param exception
     *            an exception or error
     */
    public void info(String message, Throwable exception) {
        category.log(FQCN, Level.INFO, message, exception);
    }

    /**
     * Log a debug message.
     * 
     * @param message
     *            a message
     * @param exception
     *            an exception or error
     */
    public void debug(String message, Throwable exception) {
        category.log(FQCN, Level.DEBUG, message, exception);
    }

    /**
     * Log an error.
     * 
     * @param message
     *            a message
     */
    public void error(String message) {
        category.log(FQCN, Level.ERROR, message, null);
    }

    /**
     * Log a warning.
     * 
     * @param message
     *            a message
     */
    public void warn(String message) {
        category.log(FQCN, Level.WARN, message, null);
    }

    /**
     * Log an info message.
     * 
     * @param message
     *            a message
     */
    public void info(String message) {
        category.log(FQCN, Level.INFO, message, null);
    }

    /**
     * Log a debug message.
     * 
     * @param message
     *            a message
     */
    public void debug(String message) {
        category.log(FQCN, Level.DEBUG, message, null);
    }

    /**
     * Indicates whether logging on the DEBUG level is enabled.
     * 
     * @return a boolean
     */
    public boolean isDebugEnabled() {
        return category.isDebugEnabled();
    }

    /**
     * Indicates whether logging on the INFO level is enabled.
     * 
     * @return a boolean
     */
    public boolean isInfoEnabled() {
        return category.isInfoEnabled();
    }
}